// C Source File
// Created 01/09/2004; 17:33:47

#include <tigcclib.h>

#include "..\Structs.h"
#include "..\Library.h"
#include "..\System\Error.h"
#include "..\System\String.h"
#include "..\System\Interrupt.h"
#include "..\System\Parameters.h"
#include "..\System\Functions.h"

//********************************************************
//Fonction Input
//********************************************************
unsigned short InputStr (char *buffer, unsigned short maxlen)
{ 
  SCR_STATE ss;
  unsigned short key = 0, last_key = 0;
  unsigned short i = 0;
  long repeat_delay, between_delay;
  BOOL RepeatKey = FALSE;
  buffer [0] = 0;
  SaveScrState (&ss);
  
  //'Vide' le clavier
  _kb_flush ();
  
  do
  {
  	MoveTo (ss.CurX, ss.CurY);
    printf ("%s_   ", buffer);
    
    last_key = key;
    repeat_delay = counter_time+PARAM_REPEAT_KEYDELAY;
    between_delay = counter_time+PARAM_BETWEEN_KEYDELAY;
    while (!(key = _kb_getkey (CALCULATOR)) || key==last_key)
    {
    	if (!key) {last_key = 0; RepeatKey = FALSE;}
			else if (key && key==last_key && RepeatKey && counter_time>=between_delay) break;
			else if (key && key==last_key && !RepeatKey && counter_time>=repeat_delay) RepeatKey = TRUE;
    }
    
    if (key>=32 && key<=0xFF && i<maxlen)
      buffer [i++] = key;
    else if (key==KEY_BACKSPACE && i) 
      i--;
    buffer [i] = 0;
  } while (key!=KEY_ENTER);
  
  //Efface le tir
  MoveTo (ss.CurX, ss.CurY);
  printf ("%s   ", buffer);
    
  return i;
}


//**********************************************************
//Vrification qu'aucune touche est appuye
//**********************************************************
void _kb_flush (void)
{
	while (_kb_getkey (CALCULATOR));
}