// Header File
// Created 16/08/2004; 13:11:08
#ifndef __H_EXPRVAR
#define __H_EXPRVAR

#define nVAR_Float					nTSym_float
#define nVAR_Int						nTSym_integer
#define nVAR_Bool						nTSym_bool
#define nVAR_String					nTSym_string

#define nVAR_TFloat					nTSym_tblfloat
#define nVAR_TInt						nTSym_tblinteger
#define nVAR_TBool					nTSym_tblbool
#define nVAR_TString				nTSym_tblstring

#define MAX_LABEL						MAX_SYMBOL
#define MAX_GOTO						MAX_SYMBOL
#define MAX_IF							MAX_SYMBOL
#define MAX_ELSEIF					MAX_SYMBOL
#define MAX_DO							MAX_SYMBOL
#define MAX_REPEAT					MAX_SYMBOL
#define MAX_WHILE						MAX_SYMBOL

#define MAX_STRUCT					MAX_SYMBOL
#define MAX_EXITIF					MAX_SYMBOL

#define STRUCT_IF						1
#define STRUCT_DO						2
#define STRUCT_REPEAT				3
#define STRUCT_WHILE				4


extern void *VarMemory;
extern void **VAR_Float;
extern void **VAR_Int;
extern void **VAR_Bool;
extern void **VAR_String;
extern s_TblVar *VAR_TFloat;
extern s_TblVar *VAR_TInt;
extern s_TblVar *VAR_TBool;
extern s_TblVar *VAR_TString;

extern unsigned short *TblLabelAddress;
extern s_GotoJump *TblGotoJump;
extern unsigned short nTblGotoJump;

extern unsigned char *TblStruct;
extern unsigned short nTblStruct;
extern unsigned short nTblStructExitIf;
extern unsigned char *nTblExitIf;
extern unsigned short *TblExitIf;
extern unsigned short TotalExitIf;

extern s_IFJump *Tbl_IF_Jump;
extern unsigned short n_IF_Jump;
extern unsigned short *Tbl_ElseIf_Address;
extern unsigned short TotalElseIf;
extern unsigned short *Tbl_Do_Address;
extern unsigned short TotalDo;
extern unsigned short *Tbl_Repeat_Address;
extern unsigned short TotalRepeat;
extern unsigned short *Tbl_While_Address_If;
extern unsigned short *Tbl_While_Address_Jump;
extern unsigned short TotalWhile;

extern BOOL ExprVar_Allocate (void);
extern void ExprVar_Unallocate (void);

extern void ExprVar_InitTables (void);
extern BOOL ExprVar_AllocateTables (void);
extern void ExprVar_UnallocateTables (void);

#endif