// Header File
// Created 15/08/2004; 17:18:26
#ifndef __H_TBL_TOKENS
#define __H_TBL_TOKENS

#define OPRD_RESULT											0x00
#define OPRD_NUMBER											0x01
#define OPRD_STRING											0x02
#define OPRD_VAR												0x03
#define OPRD_VARTABLE										0x04
#define OPRD_UNDEF_VARTABLE							0x05
#define OPRD_EMPTY_VARTABLE							0x06
#define OPRD_POINT_VIRGULE							0x07
#define OPRD_APOST											0x08

#define TYPE_NONE												0x00	
#define TYPE_FLOAT											0x01
#define TYPE_INT												0x02
#define TYPE_BOOL												0x03
#define TYPE_STRING											0x04

//****************
//Liste des tokens
//****************
#define ETOKEN_NONE											0x00				//Pas d'opration, alignement adresse paire
#define ETOKEN_JUMP											0x01				//Ajoute adresse dans la pile soit 4 octets suivants
#define ETOKEN_IF												0x02
#define ETOKEN_IFJUMP										0x03
#define ETOKEN_CLEAR										0x04
#define ETOKEN_EOFLINE									0x05				//Fin de ligne
#define ETOKEN_ENDTAG										0x06				//Fin des arguments pour une fonctions
#define ETOKEN_POINT_VIRGULE						0x07				//Point virgule, seulement pour PRINT
#define ETOKEN_APOST										0x08				//Apostrophe, seulement pour PRINT

#define ETOKEN_NUMBER_FLOAT							0x09
#define ETOKEN_NUMBER_INT								0x0A
#define ETOKEN_STRING										0x0B				//Suivie de 2 octets pour info taille

#define ETOKEN_VAR_FLOAT								0x0C				//Variable type float
#define ETOKEN_VAR_STRING								0x0D				//Variable type integer
#define ETOKEN_VAR_INT									0x0E				//Variable type boolens
#define ETOKEN_VAR_BOOL									0x0F				//Variable type chane de caractres

#define ETOKEN_VAR_TFLOAT								0x10				//Tableau type float
#define ETOKEN_VAR_TSTRING							0x11				//Tableau type integer
#define ETOKEN_VAR_TINT									0x12				//Tableau type boolens
#define ETOKEN_VAR_TBOOL								0x13				//Tableau type chane de caractres


//Maths
//-----
#define ETOKEN_MATH_ADD									0x14
#define ETOKEN_MATH_SUB									0x15
#define ETOKEN_MATH_MUL									0x16
#define ETOKEN_MATH_DIV									0x17
#define ETOKEN_MATH_PUISS								0x18

//Comparaison
//-----------
#define ETOKEN_COMPARE_SUPERIOR					0x19
#define ETOKEN_COMPARE_INFERIOR					0x1A
#define ETOKEN_COMPARE_EGAL							0x1B
#define ETOKEN_COMPARE_SUPEGAL					0x1C
#define ETOKEN_COMPARE_INFEGAL					0x1D
#define ETOKEN_COMPARE_DIFF							0x1E

//Affectation
//-----------
#define ETOKEN_AFFEC										0x1F

//Logique
//-------
#define ETOKEN_LOGIC_NOT								0x20
#define ETOKEN_LOGIC_AND								0x21
#define ETOKEN_LOGIC_OR									0x22
#define ETOKEN_LOGIC_XOR								0x23
#define ETOKEN_LOGIC_IMP								0x24
#define ETOKEN_LOGIC_EQV								0x25
#define ETOKEN_MATH_MOD									0x26
#define ETOKEN_MATH_DIVINT							0x27
	
//Ngatif
//-------
#define ETOKEN_NEGATIF									0x28

//Fonctions
//---------
#define ETOKEN_FUNC_AT									0x29
#define ETOKEN_FUNC_PRINT								0x2A
#define ETOKEN_FUNC_DIM									0x2B
#define ETOKEN_FUNC_CLS									0x2C
#define ETOKEN_FUNC_GETKEY							0x2D
#define ETOKEN_FUNC_ABS									0x2E
#define ETOKEN_FUNC_ADD									0x2F
#define ETOKEN_FUNC_ATN									0x30
#define ETOKEN_FUNC_CLR									0x31
#define ETOKEN_FUNC_COS									0x32
#define ETOKEN_FUNC_DEC									0x33
#define ETOKEN_FUNC_DIV									0x34
#define ETOKEN_FUNC_EVEN								0x35
#define ETOKEN_FUNC_EXP									0x36
#define ETOKEN_FUNC_FIX									0x37
#define ETOKEN_FUNC_FRAC								0x38
#define ETOKEN_FUNC_INC									0x39
#define ETOKEN_FUNC_LOG									0x3A
#define ETOKEN_FUNC_LOG10								0x3B
#define ETOKEN_FUNC_MUL									0x3C
#define ETOKEN_FUNC_ODD									0x3D
#define ETOKEN_FUNC_SGN									0x3E
#define ETOKEN_FUNC_SIN									0x3F
#define ETOKEN_FUNC_SQR									0x40
#define ETOKEN_FUNC_TAN									0x41
#define ETOKEN_FUNC_ROUND								0x42
#define ETOKEN_FUNC_SUB									0x43
#define ETOKEN_FUNC_ASC									0x44
#define ETOKEN_FUNC_BIN									0x45
#define ETOKEN_FUNC_HEX									0x46
#define ETOKEN_FUNC_OCT									0x47
#define ETOKEN_FUNC_CHR									0x48
#define ETOKEN_FUNC_LEFT								0x49
#define ETOKEN_FUNC_LEN									0x4A
#define ETOKEN_FUNC_MID									0x4B
#define ETOKEN_FUNC_RIGHT								0x4C
#define ETOKEN_FUNC_SPACE								0x4D
#define ETOKEN_FUNC_STR									0x4E
#define ETOKEN_FUNC_STRING							0x4F
#define ETOKEN_FUNC_UPPER								0x50
#define ETOKEN_FUNC_VAL									0x51
#define ETOKEN_FUNC_ARRAYFILL						0x52
#define ETOKEN_FUNC_LDIM								0x53
#define ETOKEN_FUNC_END									0x54
#define ETOKEN_FUNC_FRE									0x55
#define ETOKEN_FUNC_PAUSE								0x56
#define ETOKEN_FUNC_SWAP								0x57
#define ETOKEN_FUNC_MKI									0x58
#define ETOKEN_FUNC_MKL									0x59
#define ETOKEN_FUNC_MKF									0x5A
#define ETOKEN_FUNC_CVI									0x5B
#define ETOKEN_FUNC_CVL									0x5C
#define ETOKEN_FUNC_CVF									0x5D
#define ETOKEN_FUNC_SETFONT							0x5E
#define ETOKEN_FUNC_GETFONT							0x5F
#define ETOKEN_FUNC_LOWER								0x60
#define ETOKEN_FUNC_RUN									0x61
#define ETOKEN_FUNC_NGETCHX							0x62
#define ETOKEN_FUNC_RND									0x63
#define ETOKEN_FUNC_TIMER								0x64
#define ETOKEN_FUNC_SYSTEM							0x65
#define ETOKEN_FUNC_CRSLIN							0x66
#define ETOKEN_FUNC_CRSCOL							0x67
#define ETOKEN_FUNC_RANDOM							0x68
#define ETOKEN_FUNC_TYPE								0x69
#define ETOKEN_FUNC_LVAL								0x6A
#define ETOKEN_FUNC_VARPTR							0x6B
#define ETOKEN_FUNC_ARRPTR							0x6C
#define ETOKEN_FUNC_DFREE								0x6D
#define ETOKEN_FUNC_PEEK								0x6E
#define ETOKEN_FUNC_DPEEK								0x6F
#define ETOKEN_FUNC_LPEEK								0x70
#define ETOKEN_FUNC_POKE								0x71
#define ETOKEN_FUNC_DPOKE								0x72
#define ETOKEN_FUNC_LPOKE								0x73
#define ETOKEN_FUNC_BOX									0x74
#define ETOKEN_FUNC_INPUT								0x75
#define ETOKEN_FUNC_TEXT								0x76
#define ETOKEN_FUNC_PLOT								0x77

#endif